//---------------------------------------------------------------------------
// Copyright (C) 1997-2010 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: dropdown.js
//
// Description:
//
// A tweaked plugin that does dropdowns with check boxes.
// depends on some css and image files being present.
// 
// Author: Nasron Cheong
// Date:   Oct 2010
// Revision: $Revision: 1.1.2.1 $
//
// Last Edit Date: $Date: 2011-03-25 13:46:24 $
// Source: $Source: /home/cvs/cvsroot/DBD/web_docs/dropdown.js,v $
//---------------------------------------------------------------------------


/** @license
 * DropDown jQuery Plugin v1.0
 * Created by Andrew Timney, http://www.andytimney.com
 * With modifications by iNTERFACEWARE Inc.
 */

$(function(){
	
	$.fn.dropdown = function(options){
		
		var opts  = $.extend({}, $.fn.dropdown.defaults, options);
        var mouse_is_inside = false;

        $('body').mouseup(function(){ 
              if(! mouse_is_inside) $('#'+opts.id).remove();
           });
		
		$('.'+opts.optionClassName,$('#'+opts.id)).die('click');
		$('.'+opts.optionClassName,$('#'+opts.id)).live('click', function(e){
			var img = $(this).children('img:first');
			var isChecked = false;
			if(img.attr('src') === opts.checkedImage){
				img.attr('src', opts.image);
			}else{
				img.attr('src', opts.checkedImage);
				isChecked = true;
			}
            var id = $(this).attr('id');
			var opt_index = 0;
            for (opt_index in opts.items) {
               if (opts.items[opt_index].key == id) break;
            }
            opts.items[ opt_index  ].isChecked = isChecked;
            opts.itemClick($(this).text(), id, isChecked);
			e.preventDefault();
		});
			
		return this.each(function(i){
            $(this)
			.click(function(e){
				
				var offset = $(this).parent().offset();
	            var top = offset.top + opts.positionOffset;
				
				if ($('#'+opts.id).length > 0) {
	                $('#'+opts.id).remove();
	            }else{
					
					$('<div id="' + opts.id + '" class="'+opts.className+'"></div>')
					.css({ top: top, left: offset.left })
                    .hover(function(){ 
                          mouse_is_inside=true; 
                       }, function(){ 
                          mouse_is_inside=false; 
                       })
					.appendTo('body');
					
					$.each(opts.items, function(i, item){
						var image = opts.image;
						if (item.isChecked)
							image = opts.checkedImage;
						$('<div class="'+opts.optionClassName+'" id="' + item.key + '" ><img src="' + image + '" alt="checkbox" />' + item.value + '</div>')
                        .appendTo('#'+opts.id);
					});
					$('#'+opts.id).show();
				}
				e.preventDefault();
			})
            .hover(function(){ 
                  mouse_is_inside=true; 
               }, function(){ 
                  mouse_is_inside=false; 
            })
		});
		
	};
	
	$.fn.dropdown.defaults = {
		items:[],
        id: 'dropdown_list',
		image:'images/checkbox.png',
		checkedImage:'images/checked.png',
		positionOffset: 20,
		className: 'dropDownMenu',
		optionClassName: 'optionCheckbox',
		itemClick: function(key, value, isChecked){}
	};
	
});
