<?cs # mapper - the component.
       isInitialized - is the mapper initialized?
       mapperPrefix - the prefix to use for form input names.
       componentType - the component type (eg, 'Destination').
       componentName - the component name (eg, 'To Translator').
       rowClassName - the class name to give to all rows. ?>
<?cs def:renderMapperForm(mapper, isInitialized, mapperPrefix, componentType, componentName, rowClassName, firstRow) ?>

   <script defer type="text/javascript"> <!--

   $(document).ready(function() {
    DMPRon<?cs var:mapperPrefix ?>MilestoneRadioChange();
   });

   function DMPRon<?cs var:mapperPrefix ?>MilestoneRadioChange(){
    if ($('#<?cs var:mapperPrefix ?>UseMostRecent').attr('checked')){
     $('#<?cs var:mapperPrefix ?>Milestone').attr('disabled', 'disabled');
    } else {
     $('#<?cs var:mapperPrefix ?>Milestone').removeAttr('disabled');
    }
   }

   --> </script>

   <?cs if:!isInitialized ?>
   <tr class="<?cs var:rowClassName ?> selected">
      <td class="left_column<?cs if:firstRow ?> first_row<?cs /if ?>"></td>
      <td class="inner_left<?cs if:firstRow ?> first_row<?cs /if ?>" colspan="3">
         <span class="configurationFillerText">Save the channel to begin editing the script.</span>
      </td>
   </tr>
   <input type="hidden" name="<?cs var:mapperPrefix ?>UseMostRecent" value="<?cs if:mapper.UseMostRecentMilestone ?>true<?cs else ?>false<?cs /if ?>" />
   <input type="hidden" name="<?cs var:mapperPrefix ?>Milestone"     value="<?cs var:html_escape(mapper.Milestone) ?>" />
   <?cs else ?>
   
   <tr class="<?cs var:rowClassName ?> selected">
      <td class="left_column<?cs if:firstRow ?> first_row<?cs /if ?>">Milestone</td>
      <td class="inner_left<?cs if:firstRow ?> first_row<?cs /if ?>" colspan="3">
         <?cs if:Channel.ReadOnlyMode ?>
            <?cs if:IsRunning ?>
               <?cs var:html_escape(mapper.CurrentRunningMilestone) ?>
            <?cs elif:mapper.UseMostRecentMilestone ?>
               <?cs var:html_escape(mapper.MostRecentMilestone) ?>
            <?cs else ?>
               <?cs var:html_escape(mapper.Milestone) ?>
            <?cs /if ?>
            <?cs if:mapper.UseMostRecentMilestone ?>
                <br /><br />Configured to use the most recent milestone present on channel start.
            <?cs /if ?>
         <?cs else ?>
            <input type="radio" name="<?cs var:mapperPrefix ?>UseMostRecent" value="true"  onchange="javascript:DMPRon<?cs var:mapperPrefix ?>MilestoneRadioChange();" <?cs if:mapper.UseMostRecentMilestone  ?>checked="checked"<?cs /if ?> id="<?cs var:mapperPrefix ?>UseMostRecent" /> Use most recent<br />
            <input type="radio" name="<?cs var:mapperPrefix ?>UseMostRecent" value="false" onchange="javascript:DMPRon<?cs var:mapperPrefix ?>MilestoneRadioChange();" <?cs if:!mapper.UseMostRecentMilestone ?>checked="checked"<?cs /if ?> />
            <select name="<?cs var:mapperPrefix ?>Milestone" id="<?cs var:mapperPrefix ?>Milestone">
            <?cs each:ms = mapper.AllMilestones ?>
               <option value="<?cs var:html_escape(ms) ?>" <?cs if:ms == mapper.Milestone ?>selected="selected"<?cs /if ?>><?cs var:html_escape(ms) ?></option>
            <?cs /each ?>
            </select>
         <?cs /if ?>
      </td>
   </tr>

   <tr class="<?cs var:rowClassName ?> selected">
      <td class="left_column">Script</td>
      <td class="inner_left" colspan="3">
         <?cs # TODO - ChannelGuid parameter should be called "MapperGuid". ?>
         <?cs if:CurrentUserCanReconfigure ?>			   
           <a class='edit_permission_required' href="/mapper/?Page=OpenEditor&MapperGuid=<?cs var:mapper.Guid ?>">Edit Script...</a>
         <?cs else  ?>
	   You do not have the necessary permissions to edit the script.
         <?cs /if ?>
      </td>
   </tr>
   
   <?cs /if ?>
   
<?cs /def ?>
