<?cs include:"doctype.cs" ?>

<?cs # vim: set syntax=html :?>

<html>

<head>
   <title>Iguana <?cs if:ServerLabel ?>(<?cs var:html_escape(ServerLabel) ?>) <?cs /if ?>&gt; Settings &gt; Remote Iguana Settings</title>
   <?cs include:"styles.cs" ?>

   <script type="text/javascript" src="<?cs var:iguana_version_js("/js/jquery142/jquery-1.4.2.js") ?>"></script>
   <script type="text/javascript">
     var RowId = <?cs var:js_escape(CountOfRemoteIguana) ?>;     

     function addRemoteRow(){
          function noDuplicates(NewValue){
	     var CountOfDuplicates = 0;
	     $(':input[type=text]').each( function(){
                if (this.value == NewValue) CountOfDuplicates++;
             });
	     //the select includes the adding input field.
             if (CountOfDuplicates > 1){
                $('#new_row_error').text( 'This entry is already in the list of remote iguanas.' );
	        return false;
             }
	     return true;
          }

	  var NewRowValue = $('#NewRowField').attr('value');
	  if (NewRowValue){
             if(!NewRowValue.match(/^(http|https):\/\/[^:]+:[0-9]+/)){
	        $('#new_row_error').text( 'Invalid format. New entry should be of the form [http/https]://<host>:<port>' );
             }
             else if (noDuplicates(NewRowValue)){
	        $('#new_row_error').text('');
      	        var RowHtml = '<tr id="row_' + RowId + '">\
	          <td><input size="50" type="text" name="RemoteIguana_' + RowId + '"></td>\
	          <td><a class="remove_button button" href="#"><span>Remove</span></a></td>\
                  </tr>'
	         $(RowHtml).insertBefore($('#adding_row'));
	         $(':input[name=RemoteIguana_'+RowId+']').attr('value',NewRowValue);
	         RowId++;
	         $('#NewRowField').attr('value','');
                 return true;
             }
          }
          else return true; //doing nothing is success
          return false;
     }
     
     function doSubmit(){
	if (addRemoteRow()){
           $('#max_row_id').attr('value', RowId);
  	   document.remote_iguana_settings.SaveChanges.click();
        }
     }

     function onLoad(){
        $('.remove_button').live('click', function() {
	   var ElRowId = $(this).parent().parent().attr('id');
	   $('#' + ElRowId).remove();
        });
        $('#add_button').live('click', function() { addRemoteRow(); });

        //this sets up Enter key behaviour to add a row
        $(document).keypress(function(e){
         if (e.keyCode === 13) 
         { 
            e.preventDefault();
	    addRemoteRow();
         }
   });


     }

   </script>

</head>

<body class="tabright" onLoad="onLoad()">
<?cs set:Navigation.CurrentTab = "Settings" ?>
<?cs include:"header.cs" ?>

<div id="main">

   <table id="iguana">
      <tr>
         <td id="cookie_crumb">
            <a href="/advanced.html">Settings</a> &gt; Remote Iguana Settings
         </td>
      </tr>
      <tr>
         <td id="dashboard_body" style="text-align: center;"><center>

	 <form name="remote_iguana_settings" id="remote_iguana_settings" method="post" action="/remote_iguana_settings.html">
	 <input type="hidden" id="max_row_id" name="max_row_id" value="<?cs var:html_escape(CountOfRemoteIguana) ?>">
	 <div style="width: 30%">
         <table class="configuration" style="width: 100%" id="remote_iguana_table" border="1">
            <tr class="header">
            <th>Remote Iguanas</th>
            <th>Add/Remove</th>
            </tr>
            <?cs each:Remote = RemoteIguana ?>
            <tr id="row_<?cs name:Remote ?>" > 
	       <td class="remote_iguana_entry">
                   <input size="50" type="hidden" name="OrigRemoteIguana_<?cs name:Remote ?>" 
	                  value="<?cs var:html_escape(Remote.OrigId) ?>">
                   <input size="50" type="text" name="RemoteIguana_<?cs name:Remote ?>" 
	                  value="<?cs var:html_escape(Remote.Id) ?>">
                   <?cs if:Remote.Error ?><small style="color: #e00101"><?cs var:html_escape(Remote.Error) ?></small><?cs /if ?>
              </td>
	       <td><a class="remove_button button" href="#"><span>Remove</span></a></td>
            </tr>    
	    <?cs /each ?> 
	    <?cs if:CanAdmin ?>
	    <tr id="adding_row">
              <td class="remote_iguana_entry"><input size="50" type="text" id="NewRowField"></input>
                  <small style="color: #e00101"><span id="new_row_error"></span></small>
              </td>
              <td><a class="button" id="add_button"><span>Add</span></a></td>
            </tr>
	    <?cs /if ?>
	 </table>
	 </div>
      <p>

      <table id="buttons"><tr><td>
      <!-- edit link -->
      <?cs if:CanAdmin ?>
         <input type="submit" class="hidden_submit" name="SaveChanges" value="yes" />
         <a class="button" id="apply_changes_button" href="javascript:doSubmit();"><span><img src="../<?cs var:skin("images/icon_save.gif") ?>" /> &nbsp;Save Changes</span></a>
      <?cs else ?>
         <div class="button_disable" id="DisabledEditButton" onMouseOver="TOOLtooltipLink('You do not have the necessary permissions to edit these settings.', null, this);" onMouseOut="TOOLtooltipClose();" onmouseup="TOOLtooltipClose();" ><span><img src="../<?cs var:skin("images/icon_edit_disable.gif") ?>"/> &nbsp;Save</span></div>
     <?cs /if ?>
	 </form>
      </td>
      <td>
         <a class="button" href="/remote_iguana_settings_view.html"><span>Cancel</span></a>
      </td>
      </tr></table>
        </center>
         </td>
      </tr>
   </table>
</div>

<div id="side_panel">
   <table id="side_table">
      <tr>
         <th id="side_header">
	    Page Help
	 </th>
      </tr>
      <tr>
         <td id="side_body">
	    <h4 class="side_title">Overview</h4>
	    <p>
	       This page is used to list Iguana instances that can be accessed remotely through the dashboard. The same instances are also used when synchronizing user/permissions.
	    </p>
	    <p>
	       Instances should be of the form 'http://server:port'.
	    </p>
	 </td>
      </tr>
   </table>
</div>

</body>

</html>

